/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : hal_adc.h
  * Created on      : 24-09-2023
  * Author          : Tahir.Shaikh
  * @brief          : Source/Header file
  ******************************************************************************
  */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef ECU_HAL_IO_INC_HAL_ADC_H_
#define ECU_HAL_IO_INC_HAL_ADC_H_

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "main.h"
#include "board.h"
/* USER CODE END Includes */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */
#define POT_ADC_MAP_MIN		0U
#define POT_ADC_MAP_MAX		4096U

#define MC_ADC_MAP_MIN		0U
#define MC_ADC_MAP_MAX		100U
/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */
/* USER CODE END EM */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */
typedef enum
{
	ADCA_IN0,
	ADCA_IN1,
	ADCA_IN2,
	ADCA_IN3,
	ADCA_IN4,
	ADCA_IN5,

	ADCA_PIN_MaxCnt,
} ADCA_PinTypeDef;

typedef enum
{
    ADCB_IN0,
    ADCB_IN1,
    ADCB_IN2,
    ADCB_IN3,
    ADCB_IN4,
    ADCB_IN5,
    ADCB_IN14,
    ADCB_IN15,

    ADCB_PIN_MaxCnt,
} ADCB_PinTypeDef;

// Methods Declaration
HAL_PinConfig ADCA_bPinConfig(ADCA_PinTypeDef enPinTypeDef);
HAL_PinConfig ADCB_bPinConfig(ADCB_PinTypeDef enPinTypeDef);
//extern HAL_ADC_Value IoADCA_tReadSingleChannel(ADCA_PinTypeDef enPinTypeDef);
//HAL_ADC_Value IoADCB_tReadSingleChannel(ADCB_PinTypeDef enPinTypeDef);
/* USER CODE END ET */

/* Exported functions prototypes ---------------------------------------------*/
/* USER CODE BEGIN EFP */
// ADCA : IoADCA_tReadSingleChannel
static HAL_ADC_Value IoADCA_tReadSingleChannel(ADCA_PinTypeDef enPinTypeDef)
{
    HAL_ADC_Value AdcReadChannel;
    if (enPinTypeDef < ADCA_PIN_MaxCnt)
    {
        switch(enPinTypeDef)
        {
            case ADCA_IN0:
                AdcReadChannel = ADC_readResult(myADC0_RESULT_BASE, myADC0_SOC0);   // MCU PIN 25
                break;
            case ADCA_IN1:
                AdcReadChannel = ADC_readResult(myADC0_RESULT_BASE, myADC0_SOC1);   // MCU PIN 24
                break;
            case ADCA_IN2:
                AdcReadChannel = ADC_readResult(myADC0_RESULT_BASE, myADC0_SOC2);   // MCU PIN 23
                break;
            case ADCA_IN3:
                AdcReadChannel = ADC_readResult(myADC0_RESULT_BASE, myADC0_SOC3);   // MCU PIN 22
                break;
            case ADCA_IN4:
                AdcReadChannel = ADC_readResult(myADC0_RESULT_BASE, myADC0_SOC4);   // MCU PIN 21
                break;
            case ADCA_IN5:
                AdcReadChannel = ADC_readResult(myADC0_RESULT_BASE, myADC0_SOC5);   // MCU PIN 20
                break;
            default:
            case ADCA_PIN_MaxCnt:
                AdcReadChannel = 0;
                break;
        }
    }
    return AdcReadChannel;
}

// ADCB : IoADCB_tReadSingleChannel
static HAL_ADC_Value IoADCB_tReadSingleChannel(ADCB_PinTypeDef enPinTypeDef)
{
    HAL_ADC_Value AdcReadChannel;
    if (enPinTypeDef < ADCB_PIN_MaxCnt)
    {
        switch(enPinTypeDef)
        {
            case ADCB_IN0:
                AdcReadChannel = ADC_readResult(myADC1_RESULT_BASE, myADC1_SOC0);   // MCU PIN 25
                break;
            case ADCB_IN1:
                AdcReadChannel = ADC_readResult(myADC1_RESULT_BASE, myADC1_SOC1);   // MCU PIN 24
                break;
            case ADCB_IN2:
                AdcReadChannel = ADC_readResult(myADC1_RESULT_BASE, myADC1_SOC2);   // MCU PIN 23
                break;
            case ADCB_IN3:
                AdcReadChannel = ADC_readResult(myADC1_RESULT_BASE, myADC1_SOC3);   // MCU PIN 22
                break;
            case ADCB_IN4:
                AdcReadChannel = ADC_readResult(myADC1_RESULT_BASE, myADC1_SOC4);   // MCU PIN 21
                break;
            case ADCB_IN5:
                AdcReadChannel = ADC_readResult(myADC1_RESULT_BASE, myADC1_SOC5);   // MCU PIN 20
                break;
            case ADCB_IN14:
                AdcReadChannel = ADC_readResult(myADC1_RESULT_BASE, myADC1_SOC6);   // MCU PIN 20
                break;
            case ADCB_IN15:
                AdcReadChannel = ADC_readResult(myADC1_RESULT_BASE, myADC1_SOC7);   // MCU PIN 20
                break;

            default:
            case ADCB_PIN_MaxCnt:
                AdcReadChannel = 0;
                break;
        }
    }
    return AdcReadChannel;
}

/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
/* USER CODE BEGIN Private defines */
/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* ECU_HAL_IO_INC_HAL_ADC_H_ */
