/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : hal_pwm.h
  * Created on      : 24-09-2023
  * Author          : Tahir.Shaikh
  * @brief          : Source/Header file
  ******************************************************************************
  */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef ECU_HAL_IO_INC_HAL_PWM_H_
#define ECU_HAL_IO_INC_HAL_PWM_H_

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "main.h"
#include "driverlib.h"
#include "board.h"
/* USER CODE END Includes */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */
#define MIN_DUTY_CYCLE 0
#define MAX_DUTY_CYCLE 100
/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */
/* USER CODE END EM */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */
typedef enum
{
    myEPWM2A_Pin=0,
    myEPWM2B_Pin,
    myEPWM6A_Pin,
    myEPWM6B_Pin,
    myEPWM7A_Pin,
    myEPWM7B_Pin,
    myEPWM8A_Pin,
    myEPWM8B_Pin,
    myEPWM9A_Pin,

    PWM_PIN_MaxCnt,
} PWM_PinTypeDef;

// Methods Declaration
HAL_PinConfig PWM_bPinConfig(PWM_PinTypeDef enPinTypeDef);
HAL_ApiState PWM_bStart(PWM_PinTypeDef enPinTypeDef);
HAL_ApiState PWM_bStop(PWM_PinTypeDef enPinTypeDef);
HAL_ApiState PWM_vSetDutyCycle(PWM_PinTypeDef enPinTypeDef, uint8_t u8DutyCycle);
/* USER CODE END ET */

/* Exported functions prototypes ---------------------------------------------*/
/* USER CODE BEGIN EFP */
/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
/* USER CODE BEGIN Private defines */
/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* ECU_HAL_IO_INC_HAL_PWM_H_ */
