/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : hal_gpio.c
  * Created on      : 24-09-2023
  * Author          : Tahir.Shaikh
  * @brief          : Source/Header file
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "hal_gpio.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN TD */
/* USER CODE END TD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN PV */
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
/* USER CODE BEGIN PFP */
/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
/* USER CODE END 0 */

/* External variables --------------------------------------------------------*/
/* USER CODE BEGIN EV */
/* USER CODE END EV */

/**
  * @brief  This function is used to read back Initialized PIN status.
  * @param  GPI_PinTypeDef
  * @retval HAL_PinConfig
  */
HAL_PinConfig GPI_bPinConfig(GPI_PinTypeDef enPinTypeDef)
{
    HAL_PinConfig bPinConfig = HAL_PIN_NOT_CONFIG;

    switch(enPinTypeDef)
    {
        case myGPIO_0:
            if (GPIO_getDirectionMode(myGPIO0) == GPIO_DIR_MODE_IN)
                bPinConfig = HAL_PIN_CONFIG;
            break;
        case myGPIO_1:
            if (GPIO_getDirectionMode(myGPIO1) == GPIO_DIR_MODE_IN)
                bPinConfig = HAL_PIN_CONFIG;
            break;
        case myGPIO_2:
            if (GPIO_getDirectionMode(myGPIO2) == GPIO_DIR_MODE_IN)
                bPinConfig = HAL_PIN_CONFIG;
            break;

        default:
            case GPI_PIN_MaxCnt:
                bPinConfig = HAL_PIN_NOT_CONFIG;
            break;
    }
    return bPinConfig;
}

/**
  * @brief  This function is used to read back Initialized PIN status.
  * @param  GPO_PinTypeDef
  * @retval HAL_PinConfig
  */
HAL_PinConfig GPO_bPinConfig(GPO_PinTypeDef enPinTypeDef)
{
    HAL_PinConfig bPinConfig = HAL_PIN_NOT_CONFIG;

    switch(enPinTypeDef)
    {
        case myGPIO_3:
            if (GPIO_getDirectionMode(myGPIO3) == GPIO_DIR_MODE_OUT)
                bPinConfig = HAL_PIN_CONFIG;
            break;
        case myGPIO_4:
            if (GPIO_getDirectionMode(myGPIO4) == GPIO_DIR_MODE_OUT)
                bPinConfig = HAL_PIN_CONFIG;
            break;
        case myGPIO_5:
            if (GPIO_getDirectionMode(myGPIO5) == GPIO_DIR_MODE_OUT)
                bPinConfig = HAL_PIN_CONFIG;
            break;
        case myGPIO_6:
            if (GPIO_getDirectionMode(myGPIO6) == GPIO_DIR_MODE_OUT)
                bPinConfig = HAL_PIN_CONFIG;
            break;

        default:
            case GPO_PIN_MaxCnt:
                bPinConfig = HAL_PIN_NOT_CONFIG;
            break;
    }
    return bPinConfig;
}
/**
  * @brief  This function is used to set PIN level high/low.
  * @param  GPO_PinTypeDef
  * @param  HAL_PinState
  * @retval HAL_ApiState
  */
HAL_PinState GPO_vPinSetLevel(GPO_PinTypeDef enPinTypeDef, HAL_PinState enPinState)
{
    switch(enPinTypeDef)
    {
        case myGPIO_3:
            GPIO_writePin(myGPIO3, enPinState);
            break;
        case myGPIO_4:
            GPIO_writePin(myGPIO4, enPinState);
            break;
        case myGPIO_5:
            GPIO_writePin(myGPIO5, enPinState);
            break;
        case myGPIO_6:
            GPIO_writePin(myGPIO6, enPinState);
            break;

        default:
        case GPO_PIN_MaxCnt:
            break;
    }
    return enPinState;
}

/**
  * @brief  This function is used to get PIN level high/low.
  * @param  GPI_PinTypeDef
  * @retval HAL_PinState
  */
HAL_PinState GPI_bPinGetLevel(GPI_PinTypeDef enPinTypeDef)
{
    HAL_PinState enPinState = HAL_PIN_LOW;
    switch(enPinTypeDef)
    {
        case myGPIO_0:
            enPinState = (HAL_PinState)GPIO_readPin(myGPIO0);
            break;
        case myGPIO_1:
            enPinState = (HAL_PinState)GPIO_readPin(myGPIO1);
            break;
        case myGPIO_2:
            enPinState = (HAL_PinState)GPIO_readPin(myGPIO2);
            break;

        default:
        case GPI_PIN_MaxCnt:
            break;
    }
    return enPinState;
}
