/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : hal_pwm.c
  * Created on      : 24-09-2023
  * Author          : Tahir.Shaikh
  * @brief          : Source/Header file
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include <hal_pwm.h>
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN TD */
/* USER CODE END TD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */
//#define HAL_TIM1_PWM htim1
/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN PV */
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
/* USER CODE BEGIN PFP */
/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
/* USER CODE END 0 */

/* External variables --------------------------------------------------------*/
/* USER CODE BEGIN EV */
//extern TIM_HandleTypeDef htim1;
/* USER CODE END EV */

/**
  * @brief  This function is used to read back Initialized PIN status.
  * @param  PWM_PinTypeDef
  * @retval HAL_PinConfig
  */
HAL_PinConfig PWM_bPinConfig(PWM_PinTypeDef enPinTypeDef)
{
    HAL_PinConfig bPinConfig = HAL_PIN_NOT_CONFIG;

//    switch(enPinTypeDef)
//    {
//        case myEPWM2A_Pin:
//            bPinConfig = (HAL_PinConfig)bBIT(HAL_TIM1_PWM.Instance->CCMR1 & TIM_CCMR1_OC1PE);
//            break;
//        case myEPWM2B_Pin:
//            bPinConfig = (HAL_PinConfig)bBIT(HAL_TIM1_PWM.Instance->CCMR1 & TIM_CCMR1_OC2PE);
//            break;
//        case myEPWM6A_Pin:
//            bPinConfig = (HAL_PinConfig)bBIT(HAL_TIM1_PWM.Instance->CCMR1 & TIM_CCMR2_OC3PE);
//            break;
//        case myEPWM6B_Pin:
//            bPinConfig = (HAL_PinConfig)bBIT(HAL_TIM1_PWM.Instance->CCMR1 & TIM_CCMR1_OC1PE);
//            break;
//        case myEPWM7A_Pin:
//            bPinConfig = (HAL_PinConfig)bBIT(HAL_TIM1_PWM.Instance->CCMR1 & TIM_CCMR1_OC2PE);
//            break;
//        case myEPWM7B_Pin:
//            bPinConfig = (HAL_PinConfig)bBIT(HAL_TIM1_PWM.Instance->CCMR1 & TIM_CCMR2_OC3PE);
//            break;
//        case myEPWM8A_Pin:
//            bPinConfig = (HAL_PinConfig)bBIT(HAL_TIM1_PWM.Instance->CCMR1 & TIM_CCMR1_OC1PE);
//            break;
//        case myEPWM8B_Pin:
//            bPinConfig = (HAL_PinConfig)bBIT(HAL_TIM1_PWM.Instance->CCMR1 & TIM_CCMR1_OC2PE);
//            break;
//        case myEPWM9A_Pin:
//            bPinConfig = (HAL_PinConfig)bBIT(HAL_TIM1_PWM.Instance->CCMR1 & TIM_CCMR2_OC3PE);
//            break;
//
//        default:
//        case PWM_PIN_MaxCnt:
//            break;
//    }

    return bPinConfig;
}

/**
  * @brief  Starts the PWM signal generation.
  * @param  PWM_PinTypeDef
  * @retval HAL_ApiState
  */
HAL_ApiState PWM_bStart(PWM_PinTypeDef enPinTypeDef)
{
    HAL_ApiState enState = HAL_FAIL;

    switch(enPinTypeDef)
    {
        case myEPWM2A_Pin:
            EPWM_setActionQualifierAction(myEPWM0_BASE, EPWM_AQ_OUTPUT_A, EPWM_AQ_OUTPUT_HIGH, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPA);
            enState = HAL_SUCCESS;
        case myEPWM2B_Pin:
            EPWM_setActionQualifierAction(myEPWM0_BASE, EPWM_AQ_OUTPUT_B, EPWM_AQ_OUTPUT_HIGH, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPB);
            enState = HAL_SUCCESS;
        case myEPWM6A_Pin:
            EPWM_setActionQualifierAction(myEPWM1_BASE, EPWM_AQ_OUTPUT_A, EPWM_AQ_OUTPUT_HIGH, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPA);
            enState = HAL_SUCCESS;
        case myEPWM6B_Pin:
            EPWM_setActionQualifierAction(myEPWM1_BASE, EPWM_AQ_OUTPUT_B, EPWM_AQ_OUTPUT_HIGH, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPB);
            enState = HAL_SUCCESS;
        case myEPWM7A_Pin:
            EPWM_setActionQualifierAction(myEPWM2_BASE, EPWM_AQ_OUTPUT_A, EPWM_AQ_OUTPUT_HIGH, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPA);
            enState = HAL_SUCCESS;
        case myEPWM7B_Pin:
            EPWM_setActionQualifierAction(myEPWM2_BASE, EPWM_AQ_OUTPUT_B, EPWM_AQ_OUTPUT_HIGH, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPB);
            enState = HAL_SUCCESS;
        case myEPWM8A_Pin:
            EPWM_setActionQualifierAction(myEPWM0_BASE, EPWM_AQ_OUTPUT_A, EPWM_AQ_OUTPUT_HIGH, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPA);
            enState = HAL_SUCCESS;
        case myEPWM8B_Pin:
            EPWM_setActionQualifierAction(myEPWM0_BASE, EPWM_AQ_OUTPUT_B, EPWM_AQ_OUTPUT_HIGH, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPB);
            enState = HAL_SUCCESS;
        case myEPWM9A_Pin:
            EPWM_setActionQualifierAction(myEPWM0_BASE, EPWM_AQ_OUTPUT_A, EPWM_AQ_OUTPUT_HIGH, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPA);
            enState = HAL_SUCCESS;
            break;
        default:
        case PWM_PIN_MaxCnt:
            break;
    }

    return enState;
}

/**
  * @brief  Stop the PWM signal generation.
  * @param  PWM_PinTypeDef
  * @retval HAL_ApiState
  */
HAL_ApiState PWM_bStop(PWM_PinTypeDef enPinTypeDef)
{
    HAL_ApiState enState = HAL_FAIL;

    switch(enPinTypeDef)
    {
        case myEPWM2A_Pin:
            EPWM_setActionQualifierAction(myEPWM0_BASE, EPWM_AQ_OUTPUT_A, EPWM_AQ_OUTPUT_LOW, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPA);
            enState = HAL_SUCCESS;
        case myEPWM2B_Pin:
            EPWM_setActionQualifierAction(myEPWM0_BASE, EPWM_AQ_OUTPUT_B, EPWM_AQ_OUTPUT_LOW, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPB);
            enState = HAL_SUCCESS;
        case myEPWM6A_Pin:
            EPWM_setActionQualifierAction(myEPWM1_BASE, EPWM_AQ_OUTPUT_A, EPWM_AQ_OUTPUT_LOW, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPA);
            enState = HAL_SUCCESS;
        case myEPWM6B_Pin:
            EPWM_setActionQualifierAction(myEPWM1_BASE, EPWM_AQ_OUTPUT_B, EPWM_AQ_OUTPUT_LOW, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPB);
            enState = HAL_SUCCESS;
        case myEPWM7A_Pin:
            EPWM_setActionQualifierAction(myEPWM2_BASE, EPWM_AQ_OUTPUT_A, EPWM_AQ_OUTPUT_LOW, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPA);
            enState = HAL_SUCCESS;
        case myEPWM7B_Pin:
            EPWM_setActionQualifierAction(myEPWM2_BASE, EPWM_AQ_OUTPUT_B, EPWM_AQ_OUTPUT_LOW, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPB);
            enState = HAL_SUCCESS;
        case myEPWM8A_Pin:
            EPWM_setActionQualifierAction(myEPWM0_BASE, EPWM_AQ_OUTPUT_A, EPWM_AQ_OUTPUT_LOW, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPA);
            enState = HAL_SUCCESS;
        case myEPWM8B_Pin:
            EPWM_setActionQualifierAction(myEPWM0_BASE, EPWM_AQ_OUTPUT_B, EPWM_AQ_OUTPUT_LOW, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPB);
            enState = HAL_SUCCESS;
        case myEPWM9A_Pin:
            EPWM_setActionQualifierAction(myEPWM0_BASE, EPWM_AQ_OUTPUT_A, EPWM_AQ_OUTPUT_LOW, EPWM_AQ_OUTPUT_ON_TIMEBASE_UP_CMPA);
            enState = HAL_SUCCESS;
            break;
        default:
        case PWM_PIN_MaxCnt:
            break;
    }

    return enState;}

/**
  * @brief  This function is used to set duty cycle.
  * @param  PWM_PinTypeDef
  * @param  u8DutyCycle:0-100%
  * @retval HAL_ApiState
  */
HAL_ApiState PWM_vSetDutyCycle(PWM_PinTypeDef enPinTypeDef, uint8_t u8DutyCycle)
{
    uint8_t _u8DutyCycle;
    uint16_t cnt_value;
    uint16_t TBPRD_myEPWM;

    _u8DutyCycle = (uint8_t)(u8DutyCycle < MIN_DUTY_CYCLE) ? MIN_DUTY_CYCLE : ((u8DutyCycle > MAX_DUTY_CYCLE) ? MAX_DUTY_CYCLE : u8DutyCycle);

    switch(enPinTypeDef)
    {
        case myEPWM2A_Pin:
            TBPRD_myEPWM = EPWM_getTimeBasePeriod(myEPWM0_BASE);
            cnt_value = (TBPRD_myEPWM * (100 - _u8DutyCycle) / 100);
            EPWM_setCounterCompareValue(myEPWM0_BASE, EPWM_COUNTER_COMPARE_A, cnt_value);
          break;

        case myEPWM2B_Pin:
            TBPRD_myEPWM = EPWM_getTimeBasePeriod(myEPWM0_BASE);
            cnt_value = (TBPRD_myEPWM * (100 - _u8DutyCycle) / 100);
            EPWM_setCounterCompareValue(myEPWM0_BASE, EPWM_COUNTER_COMPARE_B, cnt_value);
          break;

        case myEPWM6A_Pin:
            TBPRD_myEPWM = EPWM_getTimeBasePeriod(myEPWM1_BASE);
            cnt_value = (TBPRD_myEPWM * (100 - _u8DutyCycle) / 100);
            EPWM_setCounterCompareValue(myEPWM1_BASE, EPWM_COUNTER_COMPARE_A, cnt_value);
          break;

        case myEPWM6B_Pin:
            TBPRD_myEPWM = EPWM_getTimeBasePeriod(myEPWM1_BASE);
            cnt_value = (TBPRD_myEPWM * (100 - _u8DutyCycle) / 100);
            EPWM_setCounterCompareValue(myEPWM1_BASE, EPWM_COUNTER_COMPARE_B, cnt_value);
          break;

        case myEPWM7A_Pin:
            TBPRD_myEPWM = EPWM_getTimeBasePeriod(myEPWM2_BASE);
            cnt_value = (TBPRD_myEPWM * (100 - _u8DutyCycle) / 100);
            EPWM_setCounterCompareValue(myEPWM2_BASE, EPWM_COUNTER_COMPARE_A, cnt_value);
          break;

        case myEPWM7B_Pin:
            TBPRD_myEPWM = EPWM_getTimeBasePeriod(myEPWM2_BASE);
            cnt_value = (TBPRD_myEPWM * (100 - _u8DutyCycle) / 100);
            EPWM_setCounterCompareValue(myEPWM2_BASE, EPWM_COUNTER_COMPARE_B, cnt_value);
          break;

        case myEPWM8A_Pin:
            TBPRD_myEPWM = EPWM_getTimeBasePeriod(myEPWM3_BASE);
            cnt_value = (TBPRD_myEPWM * (100 - _u8DutyCycle) / 100);
            EPWM_setCounterCompareValue(myEPWM3_BASE, EPWM_COUNTER_COMPARE_A, cnt_value);
          break;

        case myEPWM8B_Pin:
            TBPRD_myEPWM = EPWM_getTimeBasePeriod(myEPWM3_BASE);
            cnt_value = (TBPRD_myEPWM * (100 - _u8DutyCycle) / 100);
            EPWM_setCounterCompareValue(myEPWM3_BASE, EPWM_COUNTER_COMPARE_B, cnt_value);
          break;

        case myEPWM9A_Pin:
            TBPRD_myEPWM = EPWM_getTimeBasePeriod(myEPWM4_BASE);
            cnt_value = (TBPRD_myEPWM * (100 - _u8DutyCycle) / 100);
            EPWM_setCounterCompareValue(myEPWM4_BASE, EPWM_COUNTER_COMPARE_A, cnt_value);
          break;

        default:
        case PWM_PIN_MaxCnt:
            break;
    }

    return HAL_SUCCESS;
}
